'use strict'

const env = require("./environment")

module.exports = {
    scrollPage: async (page) => {
        if (env.autoScroll === true) { 
            console.log('Scrolling through page...');
            try {
                // DOWN
                await page.evaluate(() => {
                    return new Promise((resolve, reject) => {
                        var totalHeight = 0;
                        var timer = setInterval(() => {
                            var scrollHeight = document.body.scrollHeight / 50;
                            window.scrollBy(0, scrollHeight);
                            totalHeight += scrollHeight;
                            if(totalHeight >= document.body.scrollHeight){
                                clearInterval(timer);
                                resolve();
                            }
                        }, 10);
                    })
                });
                console.log("Scrolling finished!")
                console.log("Waiting images loading...")
                await module.exports.timeout(env.imgLoad)
            } catch (e) {
                console.error(e)
                throw "Error when trying to scroll the page: " + e;
            }
        } else {
            console.log("Skipping scroll")
        }
    }
}